<template>
  <div class="p-4">
    <button @click="router.back()" class="cursor-pointer ml-2 mb-3">
      &lt; Back
    </button>
    <div class="flex flex-row items-center mb-4">
      <img
        class="rounded h-24 w-24 mr-2"
        v-show="colorMode.value == 'dark' && container.iconDark"
        :src="container.iconDark"
      />
      <img
        class="rounded h-24 w-24 mr-2"
        v-show="colorMode.value != 'dark' || !container.iconDark"
        :src="container.icon"
      />
      <div class="flex w-full">
        <hgroup>
          <div class="flex items-center gap-2">
            <h1 class="font-bold text-xl">{{ container.name }}</h1>
            <template
              v-for="version in container.versions"
              :key="version.id"
              v-if="container.launched ?? true"
              ><UBadge size="md" v-if="!version.deprecated">{{
                version.id
              }}</UBadge></template
            >
          </div>
          <h3 class="text-lg">{{ container.tagline }}</h3>
        </hgroup>
        <InputCopy class="ml-auto mr-4 w-auto max-w-[50vw]" readonly :value="`docker pull harbor.nirvati.org/library/${containerName[containerName.length - 1]}:${container.versions[0].id}`" />
      </div>
    </div>
    <div class="flex gap-2 flex-col lg:flex-row">
      <div class="lg:min-w-[70%]">
        <UCard>
          <!-- We can safely use v-html here because container definitions are part of our website right now -->
          <div v-html="container.description"></div>
        </UCard>
      </div>
      <div class="lg:w-full">
        <UCard>
          <h4 class="font-bold mb-1">Details</h4>
          <table class="w-full">
            <tbody>
              <!-- TODO: Get this dynamically -->
              <tr>
                <td class="flex py-1">Pulls</td>
                <td>0</td>
              </tr>
              <tr>
                <td class="flex py-1">Source code</td>
                <td class="py-2">
                  <a
                    :href="`https://gitlab.com/nirvati/risc-v/${containerName.join(
                      '/'
                    )}`"
                    >View on Gitlab</a
                  >
                </td>
              </tr>
              <tr>
                <td class="flex py-1">Latest build</td>
                <td class="py-2">
                  <PipelineStatus
                    :repo="`nirvati/risc-v/${containerName.join('/')}`"
                  />
                </td>
              </tr>
              <tr>
                <td class="flex py-1">Supported architectures</td>
                <td>
                  <ul class="list-disc">
                    <li v-for="arch in container.architectures" :key="arch">
                      {{ arch }}
                    </li>
                  </ul>
                </td>
              </tr>
            </tbody>
          </table>
        </UCard>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
const router = useRouter();
const route = useRoute();
const colorMode = useColorMode();

const containerName = route.params.container as string[];

const container = await queryContent("containers")
  .where({ _id: `content:containers:${containerName.join(":")}.yml` })
  .findOne();
</script>
